import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;
public class Towers extends Frame implements Runnable,ActionListener{
    Thread t;
    TextField mailserver;
    TextField popserver;
    TextField username;
    TextField password;
    Button save;
    Button loadgame;
    Button loadmails;
    TextField recipient;
    Button startgame;
    TextField recipient2;
    TextArea message;
    Button sendmessage;
    Label info;
    TextArea inbox;
    int nr=0;
    public Towers(){
        super("Astro Solutions Towers3D");
        pack();
        resize(640,480);
        setLayout(null);
        addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent w){System.exit(0);}});
        mailserver=new TextField("mail.server.com");
        popserver=new TextField("pop.server.com");
        username=new TextField("user@server.com");
        password=new TextField("pass");
        save=new Button("save");
        loadgame=new Button("load game");
        loadmails=new Button("load mails");
        recipient=new TextField("user@server.com");
        startgame=new Button("start game");
        recipient2=new TextField("user@server.com");
        message=new TextArea();
        sendmessage=new Button("send message");
        info=new Label("info");
        inbox=new TextArea();
        inbox.setText("keys: cursor keys, F1, F2, return, delete\n");
        add(mailserver);
        add(popserver);
        add(username);
        add(password);
        add(save);
        add(loadgame);
        add(loadmails);
        add(recipient);
        add(startgame);
        add(recipient2);
        add(message);
        add(sendmessage);
        add(info);
        add(inbox);
        mailserver.reshape(10,40,80,27);
        popserver.reshape(110,40,80,27);
        username.reshape(210,40,80,27);
        password.reshape(310,40,80,27);
        save.reshape(410,40,80,27);
        loadgame.reshape(10,70,200,27);
        loadmails.reshape(220,70,200,27);
        recipient.reshape(10,100,200,27);
        startgame.reshape(220,100,200,27);
        recipient2.reshape(10,130,200,27);
        message.reshape(10,160,500,100);
        sendmessage.reshape(10,270,200,27);
        info.reshape(10,300,620,27);
        inbox.reshape(10,330,600,140);
        show();
        load();
        save.addActionListener(this);
        loadgame.addActionListener(this);
        loadmails.addActionListener(this);
        startgame.addActionListener(this);
        sendmessage.addActionListener(this);
        t=new Thread(this);
        t.start();
    }
    public void run(){
    }
    public synchronized int increase(){
        int ret=nr;
        nr++;
        return ret;
    }
    public void add(String content,String fromline,String mtype) throws Exception{
        inbox.appendText(fromline+"\n");
        FileDialog fd=new FileDialog(this,mtype+" "+fromline,FileDialog.SAVE);
        fd.show();
        if(fd.getFile()!=null){
            FileOutputStream fos=new FileOutputStream(fd.getDirectory()+fd.getFile());
            PrintStream ps=new PrintStream(fos);
            ps.print(content);
            ps.close();
            fos.close();
        }
            String fs=".\\tmp\\"+increase()+".tmp";
            FileOutputStream fos=new FileOutputStream(fs);
            fos.write(content.getBytes());
            fos.close();
            FileInputStream fis=new FileInputStream(fs);
            DataInputStream dis=new DataInputStream(fis);
            String a=dis.readLine();
            a=dis.readLine();
            a=dis.readLine();
            String g1=dis.readLine();
            String g2=dis.readLine();
            if(g1!=null&&g2!=null&&"SCHACH TOWERS3D".equals(g1)&&"GAME".equals(g2)){
                Choi openc=new Choi(this,"open game");
                if(openc.okb){
                String p1name=dis.readLine();
                String p2name=dis.readLine();
                int curnum=(new Integer(dis.readLine())).intValue();
                int p1rochk=(new Integer(dis.readLine())).intValue();
                int p1rochg=(new Integer(dis.readLine())).intValue();
                int p2rochk=(new Integer(dis.readLine())).intValue();
                int p2rochg=(new Integer(dis.readLine())).intValue();
                String astr=dis.readLine();
                String bstr=dis.readLine();
                Schachbrett sb=new Schachbrett(astr,bstr,p1name,p2name,curnum);
                if(p1rochk==0){
                    sb.p1rochk=false;
                }
                if(p1rochg==0){
                    sb.p1rochg=false;
                }
                if(p2rochk==0){
                    sb.p2rochk=false;
                }
                if(p2rochg==0){
                    sb.p2rochg=false;
                }
                SchachFrame sf=new SchachFrame(sb,this);
                }
            }
            else{
                String inp="";
                while((inp=dis.readLine())!=null&&!inp.equals("--bounds")){
                    inbox.appendText(inp+"\r\n");
                }
            }
            dis.close();
            fis.close();
    }
    public void actionPerformed(ActionEvent ae){
//System.out.println(""+ae.getSource());
        if(ae.getSource()==save){
            save();
        }
        else if(ae.getSource()==loadmails){
            new POPRequester(this);
        }
        else if(ae.getSource()==sendmessage){
            String messagestr=message.getText();
            String recipientstr=recipient2.getText();
            String textstr="SCHACH TOWERS3D\r\n"+"MESSAGE"+"\r\n"+message.getText()+"\r\n";
            new MailSender(recipientstr,textstr,this);
//System.out.println("sm");
        }
        else if(ae.getSource()==startgame){
            String recipientstr=recipient.getText();
            String textstr="SCHACH TOWERS3D\r\n"+"GAME\r\n";
            textstr=textstr+recipientstr+"\r\n"+username.getText()+"\r\n";
            textstr=textstr+0+"\r\n";
            textstr=textstr+"1\r\n1\r\n1\r\n1\r\n";
            textstr=textstr+"TSTSKLTLDBBBBBBBBB000000000000000000000000000000000000000000000000000000\r\n";
            textstr=textstr+"000000000000000000000000000000000000000000000000000000BBBBBBBBBTSDSKLTLT\r\n";
            new MailSender(recipientstr,textstr,this);
        }
        else if(ae.getSource()==loadgame){
            FileDialog fd=new FileDialog(this,"load game from disk",FileDialog.LOAD);
            fd.show();
            if(fd.getFile()!=null){
                String fdf=fd.getDirectory()+fd.getFile();
                try{
                    FileInputStream fis=new FileInputStream(fdf);
                    DataInputStream dis=new DataInputStream(fis);
            String a=dis.readLine();
            a=dis.readLine();
            a=dis.readLine();
                    String g1=dis.readLine();
                    String g2=dis.readLine();
                    if(g1!=null&&g2!=null&&g1.equals("SCHACH TOWERS3D")&&g2.equals("GAME")){
                        String p1name=dis.readLine();
                        String p2name=dis.readLine();
                        int curnum=(new Integer(dis.readLine())).intValue();
                        int p1rochk=(new Integer(dis.readLine())).intValue();
                        int p1rochg=(new Integer(dis.readLine())).intValue();
                        int p2rochk=(new Integer(dis.readLine())).intValue();
                        int p2rochg=(new Integer(dis.readLine())).intValue();
                        String astr=dis.readLine();
                        String bstr=dis.readLine();
//System.out.println(astr);
//System.out.println(bstr);
                        Schachbrett sb=new Schachbrett(astr,bstr,p1name,p2name,curnum);
                        if(p1rochk==0){
                            sb.p1rochk=false;
                        }
                        if(p1rochg==0){
                            sb.p1rochg=false;
                        }
                        if(p2rochk==0){
                            sb.p2rochk=false;
                        }
                        if(p2rochg==0){
                            sb.p2rochg=false;
                        }
                        SchachFrame sf=new SchachFrame(sb,this);
                    }
                    else{
                        info.setText("file open: wrong format");
                    }
                    dis.close();
                    fis.close();
                }
                catch(Exception e){
                    info.setText("file open error: "+e);
                }
            }
        }
    }
    public void save(){
        try{
            FileOutputStream fos=new FileOutputStream("server.ini");
            PrintStream ps=new PrintStream(fos);
            ps.println(mailserver.getText());
            ps.println(popserver.getText());
            ps.println(username.getText());
            ps.println(password.getText());
            ps.close();
            fos.close();
        }
        catch(Exception e){
        }
    }
    public void load(){
        try{
            FileInputStream fis=new FileInputStream("server.ini");
            DataInputStream dis=new DataInputStream(fis);
            mailserver.setText(dis.readLine());
            popserver.setText(dis.readLine());
            username.setText(dis.readLine());
            password.setText(dis.readLine());
            dis.close();
            fis.close();
        }
        catch(Exception e){
        }
    }
    public static void main(String[]args){
        new Towers();
    }
}
class Choi extends Dialog implements ActionListener{
    Button ok;
    Button cancel;
    boolean okb=false;
    public Choi(Frame parent,String title){
        super(parent,title,true);
        pack();
        resize(200,200);
        setLayout(null);
        ok=new Button("ok");
        cancel=new Button("cancel");
        add(ok);
        add(cancel);
        ok.reshape(10,90,80,27);
        cancel.reshape(110,90,80,27);
        addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent w){hide();}});
        ok.addActionListener(this);
        cancel.addActionListener(this);
        show();
    }
    public void actionPerformed(ActionEvent ae){
//System.out.println("source: "+ae.getSource());
        if(ae.getSource()==ok){
            okb=true;
        }
        hide();
    }
}
class Schachbrett{
    int[][][]brett=new int[8][3][3];
    Moves[][][]moves=new Moves[8][3][3];
    String player1;
    String player2;
    int curnum;
    boolean p1rochk=true;
    boolean p1rochg=true;
    boolean p2rochk=true;
    boolean p2rochg=true;
    public Schachbrett(String a,String b,String player1,String player2,int curnum){
        this.player1=player1;
        this.player2=player2;
        this.curnum=curnum;
        fillbrett1(a);
        fillbrett2(b);
//System.out.println("x");
    }
    public Schachbrett(int[][][]brett,String player1,String player2,int curnum){
        this.player1=player1;
        this.player2=player2;
        this.curnum=curnum;
        int[][][]brett2=new int[8][3][3];
        for(int i=0;i<8;i++){
            for(int j=0;j<3;j++){
                for(int k=0;k<3;k++){
                    brett2[i][j][k]=brett[i][j][k];
                }
            }
        }
        this.brett=brett2;
    }
    public Schachbrett copy(){
        Schachbrett ret=new Schachbrett(brett,player1,player2,curnum);
        ret.p1rochk=p1rochk;
        ret.p1rochg=p1rochg;
        ret.p2rochk=p2rochk;
        ret.p2rochg=p2rochg;
        return ret;
    }
    public String getString(){
        byte[]by=new byte[2];
        by[0]=13;
        by[1]=10;
        String bys=new String(by);
        String ret="SCHACH TOWERS3D\r\nGAME\r\n";
        ret=ret+player1+(new String(by));
        ret=ret+player2+(new String(by));
        ret=ret+((curnum)%2)+(new String(by));
        if(p1rochk){
            ret=ret+"1"+(new String(by));
        }
        else{
            ret=ret+"0"+(new String(by));
        }
        if(p1rochg){
            ret=ret+"1"+(new String(by));
        }
        else{
            ret=ret+"0"+(new String(by));
        }
        if(p2rochk){
            ret=ret+"1"+(new String(by));
        }
        else{
            ret=ret+"0"+(new String(by));
        }
        if(p2rochg){
            ret=ret+"1"+(new String(by));
        }
        else{
            ret=ret+"0"+(new String(by));
        }
        for(int i=0;i<8;i++){
            for(int j=0;j<3;j++){
                for(int k=0;k<3;k++){
                    if(brett[i][j][k]==0){
                        ret=ret+"0";
                    }
                    else if(brett[i][j][k]==1){
                        ret=ret+"B";
                    }
                    else if(brett[i][j][k]==2){
                        ret=ret+"S";
                    }
                    else if(brett[i][j][k]==3){
                        ret=ret+"L";
                    }
                    else if(brett[i][j][k]==4){
                        ret=ret+"T";
                    }
                    else if(brett[i][j][k]==5){
                        ret=ret+"D";
                    }
                    else if(brett[i][j][k]==6){
                        ret=ret+"K";
                    }
                    else{
                        ret=ret+"0";
                    }
                }
            }
        }
        ret=ret+(new String(by));
        for(int i=0;i<8;i++){
            for(int j=0;j<3;j++){
                for(int k=0;k<3;k++){
                    if(brett[i][j][k]==0){
                        ret=ret+"0";
                    }
                    else if(brett[i][j][k]==7){
                        ret=ret+"B";
                    }
                    else if(brett[i][j][k]==8){
                        ret=ret+"S";
                    }
                    else if(brett[i][j][k]==9){
                        ret=ret+"L";
                    }
                    else if(brett[i][j][k]==10){
                        ret=ret+"T";
                    }
                    else if(brett[i][j][k]==11){
                        ret=ret+"D";
                    }
                    else if(brett[i][j][k]==12){
                        ret=ret+"K";
                    }
                    else{
                        ret=ret+"0";
                    }
                }
            }
        }
        ret=ret+(new String(by));
        return ret;
    }
    public void fillbrett1(String a){

        int pos=0;
        for(int i=0;i<8;i++){
            for(int j=0;j<3;j++){
                for(int k=0;k<3;k++){
                String ch=a.substring(pos,pos+1);
                if("0".equals(ch)){
                    brett[i][j][k]=0;
                }
                else if("B".equals(ch)){
                    brett[i][j][k]=1;
                }
                else if("S".equals(ch)){
                    brett[i][j][k]=2;
                }
                else if("L".equals(ch)){
                    brett[i][j][k]=3;
                }
                else if("T".equals(ch)){
                    brett[i][j][k]=4;
                }
                else if("D".equals(ch)){
                    brett[i][j][k]=5;
                }
                else if("K".equals(ch)){
                    brett[i][j][k]=6;
                }
                pos++;
                }
            }
        }
    }
    public void fillbrett2(String a){
        int pos=0;
        for(int i=0;i<8;i++){
            for(int j=0;j<3;j++){
                for(int k=0;k<3;k++){
                String ch=a.substring(pos,pos+1);
                if("B".equals(ch)){
                    brett[i][j][k]=7;
                }
                else if("S".equals(ch)){
                    brett[i][j][k]=8;
                }
                else if("L".equals(ch)){
                    brett[i][j][k]=9;
                }
                else if("T".equals(ch)){
                    brett[i][j][k]=10;
                }
                else if("D".equals(ch)){
                    brett[i][j][k]=11;
                }
                else if("K".equals(ch)){
                    brett[i][j][k]=12;
                }
                pos++;
                }
            }
        }
    }
    public boolean isMove(int x,int y,int z,int x2,int y2,int z2){
        int n=moves[x][y][z].x.length;
        for(int i=0;i<n;i++){
            if(moves[x][y][z].x[i]==x2&&moves[x][y][z].y[i]==y2&&moves[x][y][z].z[i]==z2){
                return true;
            }
        }
        return false;
    }
    public boolean checkp1(){
        int a=0;
        int b=0;
        int c=0;
        for(int i=0;i<8;i++){
            for(int j=0;j<3;j++){
                for(int k=0;k<3;k++){
                if(brett[i][j][k]==6){
                    a=i;
                    b=j;
                    c=k;
                }
                }
            }
        }
        for(int i=0;i<8;i++){
            for(int j=0;j<3;j++){
                for(int l=0;l<3;l++){
                if(brett[i][j][l]>=7&&moves[i][j][l]!=null){
                    int n=moves[i][j][l].x.length;
                    for(int k=0;k<n;k++){
                        if(moves[i][j][l].x[k]==a&&moves[i][j][l].y[k]==b&&moves[i][j][l].z[k]==c){
                            return true;
                        }
                    }
                }
                }
            }
        }
        return false;
    }
    public boolean checkp2(){
        int a=0;
        int b=0;
        int c=0;
        for(int i=0;i<8;i++){
            for(int j=0;j<3;j++){
                for(int k=0;k<3;k++){
                if(brett[i][j][k]==12){
                    a=i;
                    b=j;
                    c=k;
                }
                }
            }
        }
        for(int i=0;i<8;i++){
            for(int j=0;j<3;j++){
                for(int l=0;l<3;l++){
                if(brett[i][j][l]<=6&&moves[i][j][l]!=null){
                    int n=moves[i][j][l].x.length;
                    for(int k=0;k<n;k++){
                        if(moves[i][j][l].x[k]==a&&moves[i][j][l].y[k]==b&&moves[i][j][l].z[k]==c){
                            return true;
                        }
                    }
                }
                }
            }
        }
        return false;
    }
    public void getMoves(){
        for(int i=0;i<8;i++){
            for(int j=0;j<3;j++){
                for(int k=0;k<3;k++){
                moves[i][j][k]=new Moves();
                if(brett[i][j][k]<=6){
                    if(brett[i][j][k]==1){
                        if(j>=1&&i<7&&brett[i+1][j-1][k]>=7){
                            moves[i][j][k].add(i+1,j-1,k);
                        }
                        if(j<2&&i<7&&brett[i+1][j+1][k]>=7){
                            moves[i][j][k].add(i+1,j+1,k);
                        }
                        if(j>=1&&i<7&&k<2&&brett[i+1][j-1][k+1]>=7){
                            moves[i][j][k].add(i+1,j-1,k+1);
                        }
                        if(j<2&&i<7&&k<2&&brett[i+1][j+1][k+1]>=7){
                            moves[i][j][k].add(i+1,j+1,k+1);
                        }
                        if(j>=1&&i<7&&k>0&&brett[i+1][j-1][k-1]>=7){
                            moves[i][j][k].add(i+1,j-1,k-1);
                        }
                        if(j<2&&i<7&&k>0&&brett[i+1][j+1][k-1]>=7){
                            moves[i][j][k].add(i+1,j+1,k-1);
                        }
                        if(i<7&&brett[i+1][j][k]==0){
                            moves[i][j][k].add(i+1,j,k);
                        }
                        if(i==1&&brett[i+1][j][k]==0&&brett[i+2][j][k]==0){
                            moves[i][j][k].add(i+2,j,k);
                        }
                    }
                    else if(brett[i][j][k]==2){
                        if(i-1>=0&&i-1<=7&&j-2>=0&&j-2<=2&&(brett[i-1][j-2][k]==0||brett[i-1][j-2][k]>=7)){
                            moves[i][j][k].add(i-1,j-2,k);
                        }
                        if(i-1>=0&&i-1<=7&&j+2>=0&&j+2<=2&&(brett[i-1][j+2][k]==0||brett[i-1][j+2][k]>=7)){
                            moves[i][j][k].add(i-1,j+2,k);
                        }
                        if(i+1>=0&&i+1<=7&&j-2>=0&&j-2<=2&&(brett[i+1][j-2][k]==0||brett[i+1][j-2][k]>=7)){
                            moves[i][j][k].add(i+1,j-2,k);
                        }
                        if(i+1>=0&&i+1<=7&&j+2>=0&&j+2<=2&&(brett[i+1][j+2][k]==0||brett[i+1][j+2][k]>=7)){
                            moves[i][j][k].add(i+1,j+2,k);
                        }
                        if(i-2>=0&&i-2<=7&&j-1>=0&&j-1<=2&&(brett[i-2][j-1][k]==0||brett[i-2][j-1][k]>=7)){
                            moves[i][j][k].add(i-2,j-1,k);
                        }
                        if(i-2>=0&&i-2<=7&&j+1>=0&&j+1<=2&&(brett[i-2][j+1][k]==0||brett[i-2][j+1][k]>=7)){
                            moves[i][j][k].add(i-2,j+1,k);
                        }
                        if(i+2>=0&&i+2<=7&&j-1>=0&&j-1<=2&&(brett[i+2][j-1][k]==0||brett[i+2][j-1][k]>=7)){
                            moves[i][j][k].add(i+2,j-1,k);
                        }
                        if(i+2>=0&&i+2<=7&&j+1>=0&&j+1<=2&&(brett[i+2][j+1][k]==0||brett[i+2][j+1][k]>=7)){
                            moves[i][j][k].add(i+2,j+1,k);
                        }

                        if(k-1>=0&&k-1<=2&&j-2>=0&&j-2<=2&&(brett[i][j-2][k-1]==0||brett[i][j-2][k-1]>=7)){
                            moves[i][j][k].add(i,j-2,k-1);
                        }
                        if(k-1>=0&&k-1<=2&&j+2>=0&&j+2<=2&&(brett[i][j+2][k-1]==0||brett[i][j+2][k-1]>=7)){
                            moves[i][j][k].add(i,j+2,k-1);
                        }
                        if(k+1>=0&&k+1<=2&&j-2>=0&&j-2<=2&&(brett[i][j-2][k+1]==0||brett[i][j-2][k+1]>=7)){
                            moves[i][j][k].add(i,j-2,k+1);
                        }
                        if(k+1>=0&&k+1<=2&&j+2>=0&&j+2<=2&&(brett[i][j+2][k+1]==0||brett[i][j+2][k+1]>=7)){
                            moves[i][j][k].add(i,j+2,k+1);
                        }
                        if(i-2>=0&&i-2<=7&&k-1>=0&&k-1<=2&&(brett[i-2][j][k-1]==0||brett[i-2][j][k-1]>=7)){
                            moves[i][j][k].add(i-2,j,k-1);
                        }
                        if(i-2>=0&&i-2<=7&&k+1>=0&&k+1<=2&&(brett[i-2][j][k+1]==0||brett[i-2][j][k+1]>=7)){
                            moves[i][j][k].add(i-2,j,k+1);
                        }
                        if(i+2>=0&&i+2<=7&&k-1>=0&&k-1<=2&&(brett[i+2][j][k-1]==0||brett[i+2][j][k-1]>=7)){
                            moves[i][j][k].add(i+2,j,k-1);
                        }
                        if(i+2>=0&&i+2<=7&&k+1>=0&&k+1<=2&&(brett[i+2][j][k+1]==0||brett[i+2][j][k+1]>=7)){
                            moves[i][j][k].add(i+2,j,k+1);
                        }

                        if(k-2>=0&&k-2<=2&&j-1>=0&&j-1<=2&&(brett[i][j-1][k-2]==0||brett[i][j-1][k-2]>=7)){
                            moves[i][j][k].add(i,j-1,k-2);
                        }
                        if(k-2>=0&&k-2<=2&&j+1>=0&&j+1<=2&&(brett[i][j+1][k-2]==0||brett[i][j+1][k-2]>=7)){
                            moves[i][j][k].add(i,j+1,k-2);
                        }
                        if(k+2>=0&&k+2<=2&&j-1>=0&&j-1<=2&&(brett[i][j-1][k+2]==0||brett[i][j-1][k+2]>=7)){
                            moves[i][j][k].add(i,j-1,k+2);
                        }
                        if(k+2>=0&&k+2<=2&&j+1>=0&&j+1<=2&&(brett[i][j+1][k+2]==0||brett[i][j+1][k+2]>=7)){
                            moves[i][j][k].add(i,j+1,k+2);
                        }
                        if(i-1>=0&&i-1<=7&&k-2>=0&&k-2<=2&&(brett[i-1][j][k-2]==0||brett[i-1][j][k-2]>=7)){
                            moves[i][j][k].add(i-1,j,k-2);
                        }
                        if(i-1>=0&&i-1<=7&&k+2>=0&&k+2<=2&&(brett[i-1][j][k+2]==0||brett[i-1][j][k+2]>=7)){
                            moves[i][j][k].add(i-1,j,k+2);
                        }
                        if(i+1>=0&&i+1<=7&&k-2>=0&&k-2<=2&&(brett[i+1][j][k-2]==0||brett[i+1][j][k-2]>=7)){
                            moves[i][j][k].add(i+1,j,k-2);
                        }
                        if(i+1>=0&&i+1<=7&&k+2>=0&&k+2<=2&&(brett[i+1][j][k+2]==0||brett[i+1][j][k+2]>=7)){
                            moves[i][j][k].add(i+1,j,k+2);
                        }
                    }
                    else if(brett[i][j][k]==3){
                        boolean running=true;
                        int bx=i+1;
                        int by=j+1;
                        int bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }

                        running=true;
                        bx=i+1;
                        by=j+1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                                bz=bz+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }


                        running=true;
                        bx=i+1;
                        by=j+1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                                bz=bz-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                    }
                    else if(brett[i][j][k]==4){
                        boolean running=true;
                        int bx=i+1;
                        int by=j;
                        int bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j+1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }

                        running=true;
                        bx=i;
                        by=j;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                    }
                    else if(brett[i][j][k]==5){
                        boolean running=true;
                        int bx=i+1;
                        int by=j+1;
                        int bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }

                        running=true;
                        bx=i+1;
                        by=j+1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                                bz=bz+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }


                        running=true;
                        bx=i+1;
                        by=j+1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                                bz=bz-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }

                        running=true;
                        bx=i+1;
                        by=j;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j+1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }

                        running=true;
                        bx=i;
                        by=j;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]>=7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                    }
                    else if(brett[i][j][k]==6){
                        if(i+1>=0&&i+1<=7&&j+1>=0&&j+1<=2&&(brett[i+1][j+1][k]==0||brett[i+1][j+1][k]>=7)){
                            moves[i][j][k].add(i+1,j+1,k);
                        }
                        if(i+1>=0&&i+1<=7&&j-1>=0&&j-1<=2&&(brett[i+1][j-1][k]==0||brett[i+1][j-1][k]>=7)){
                            moves[i][j][k].add(i+1,j-1,k);
                        }
                        if(i+1>=0&&i+1<=7&&j>=0&&j<=2&&(brett[i+1][j][k]==0||brett[i+1][j][k]>=7)){
                            moves[i][j][k].add(i+1,j,k);
                        }
                        if(i>=0&&i<=7&&j+1>=0&&j+1<=2&&(brett[i][j+1][k]==0||brett[i][j+1][k]>=7)){
                            moves[i][j][k].add(i,j+1,k);
                        }
                        if(i>=0&&i<=7&&j-1>=0&&j-1<=2&&(brett[i][j-1][k]==0||brett[i][j-1][k]>=7)){
                            moves[i][j][k].add(i,j-1,k);
                        }
                        if(i-1>=0&&i-1<=7&&j+1>=0&&j+1<=2&&(brett[i-1][j+1][k]==0||brett[i-1][j+1][k]>=7)){
                            moves[i][j][k].add(i-1,j+1,k);
                        }
                        if(i-1>=0&&i-1<=7&&j-1>=0&&j-1<=2&&(brett[i-1][j-1][k]==0||brett[i-1][j-1][k]>=7)){
                            moves[i][j][k].add(i-1,j-1,k);
                        }
                        if(i-1>=0&&i-1<=7&&j>=0&&j<=2&&(brett[i-1][j][k]==0||brett[i-1][j][k]>=7)){
                            moves[i][j][k].add(i-1,j,k);
                        }

                        if(i+1>=0&&i+1<=7&&j+1>=0&&j+1<=2&&k+1<3&&(brett[i+1][j+1][k+1]==0||brett[i+1][j+1][k+1]>=7)){
                            moves[i][j][k].add(i+1,j+1,k+1);
                        }
                        if(i+1>=0&&i+1<=7&&j-1>=0&&j-1<=2&&k+1<3&&(brett[i+1][j-1][k+1]==0||brett[i+1][j-1][k+1]>=7)){
                            moves[i][j][k].add(i+1,j-1,k+1);
                        }
                        if(i+1>=0&&i+1<=7&&j>=0&&j<=2&&k+1<3&&(brett[i+1][j][k+1]==0||brett[i+1][j][k+1]>=7)){
                            moves[i][j][k].add(i+1,j,k+1);
                        }
                        if(i>=0&&i<=7&&j+1>=0&&j+1<=2&&k+1<3&&(brett[i][j+1][k+1]==0||brett[i][j+1][k+1]>=7)){
                            moves[i][j][k].add(i,j+1,k+1);
                        }
                        if(i>=0&&i<=7&&j-1>=0&&j-1<=2&&k+1<3&&(brett[i][j-1][k+1]==0||brett[i][j-1][k+1]>=7)){
                            moves[i][j][k].add(i,j-1,k+1);
                        }
                        if(i-1>=0&&i-1<=7&&j+1>=0&&j+1<=2&&k+1<3&&(brett[i-1][j+1][k+1]==0||brett[i-1][j+1][k+1]>=7)){
                            moves[i][j][k].add(i-1,j+1,k+1);
                        }
                        if(i-1>=0&&i-1<=7&&j-1>=0&&j-1<=2&&k+1<3&&(brett[i-1][j-1][k+1]==0||brett[i-1][j-1][k+1]>=7)){
                            moves[i][j][k].add(i-1,j-1,k+1);
                        }
                        if(i-1>=0&&i-1<=7&&j>=0&&j<=2&&k+1<3&&(brett[i-1][j][k+1]==0||brett[i-1][j][k+1]>=7)){
                            moves[i][j][k].add(i-1,j,k+1);
                        }

                        if(i+1>=0&&i+1<=7&&j+1>=0&&j+1<=2&&k-1>=0&&(brett[i+1][j+1][k-1]==0||brett[i+1][j+1][k-1]>=7)){
                            moves[i][j][k].add(i+1,j+1,k-1);
                        }
                        if(i+1>=0&&i+1<=7&&j-1>=0&&j-1<=2&&k-1>=0&&(brett[i+1][j-1][k-1]==0||brett[i+1][j-1][k-1]>=7)){
                            moves[i][j][k].add(i+1,j-1,k-1);
                        }
                        if(i+1>=0&&i+1<=7&&j>=0&&j<=2&&k-1>=0&&(brett[i+1][j][k-1]==0||brett[i+1][j][k-1]>=7)){
                            moves[i][j][k].add(i+1,j,k-1);
                        }
                        if(i>=0&&i<=7&&j+1>=0&&j+1<=2&&k-1>=0&&(brett[i][j+1][k-1]==0||brett[i][j+1][k-1]>=7)){
                            moves[i][j][k].add(i,j+1,k-1);
                        }
                        if(i>=0&&i<=7&&j-1>=0&&j-1<=2&&k-1>=0&&(brett[i][j-1][k-1]==0||brett[i][j-1][k-1]>=7)){
                            moves[i][j][k].add(i,j-1,k-1);
                        }
                        if(i-1>=0&&i-1<=7&&j+1>=0&&j+1<=2&&k-1>=0&&(brett[i-1][j+1][k-1]==0||brett[i-1][j+1][k-1]>=7)){
                            moves[i][j][k].add(i-1,j+1,k-1);
                        }
                        if(i-1>=0&&i-1<=7&&j-1>=0&&j-1<=2&&k-1>=0&&(brett[i-1][j-1][k-1]==0||brett[i-1][j-1][k-1]>=7)){
                            moves[i][j][k].add(i-1,j-1,k-1);
                        }
                        if(i-1>=0&&i-1<=7&&j>=0&&j<=2&&k-1>=0&&(brett[i-1][j][k-1]==0||brett[i-1][j][k-1]>=7)){
                            moves[i][j][k].add(i-1,j,k-1);
                        }
                    }
                }
                else{

                    if(brett[i][j][k]==7){
                        if(j>=1&&i>0&&brett[i-1][j-1][k]<=6&&brett[i-1][j-1][k]>0){
                            moves[i][j][k].add(i-1,j-1,k);
                        }
                        if(j<2&&i>0&&brett[i-1][j+1][k]<=6&&brett[i-1][j+1][k]>0){
                            moves[i][j][k].add(i-1,j+1,k);
                        }
                        if(j>=1&&i>0&&k<2&&brett[i-1][j-1][k+1]<=6&&brett[i-1][j-1][k+1]>0){
                            moves[i][j][k].add(i-1,j-1,k+1);
                        }
                        if(j<2&&i>0&&k<2&&brett[i-1][j+1][k+1]<=6&&brett[i-1][j+1][k+1]>0){
                            moves[i][j][k].add(i-1,j+1,k+1);
                        }
                        if(j>=1&&i>0&&k>0&&brett[i-1][j-1][k-1]<=6&&brett[i-1][j-1][k-1]>0){
                            moves[i][j][k].add(i-1,j-1,k-1);
                        }
                        if(j<2&&i>0&&k>0&&brett[i-1][j+1][k-1]<=6&&brett[i-1][j+1][k-1]>0){
                            moves[i][j][k].add(i-1,j+1,k-1);
                        }
                        if(i>0&&brett[i-1][j][k]==0){
                            moves[i][j][k].add(i-1,j,k);
                        }
                        if(i==6&&brett[i-1][j][k]==0&&brett[i-2][j][k]==0){
                            moves[i][j][k].add(i-2,j,k);
                        }
                    }
                    else if(brett[i][j][k]==8){
                        if(i-1>=0&&i-1<=7&&j-2>=0&&j-2<=2&&(brett[i-1][j-2][k]==0||brett[i-1][j-2][k]<7)){
                            moves[i][j][k].add(i-1,j-2,k);
                        }
                        if(i-1>=0&&i-1<=7&&j+2>=0&&j+2<=2&&(brett[i-1][j+2][k]==0||brett[i-1][j+2][k]<7)){
                            moves[i][j][k].add(i-1,j+2,k);
                        }
                        if(i+1>=0&&i+1<=7&&j-2>=0&&j-2<=2&&(brett[i+1][j-2][k]==0||brett[i+1][j-2][k]<7)){
                            moves[i][j][k].add(i+1,j-2,k);
                        }
                        if(i+1>=0&&i+1<=7&&j+2>=0&&j+2<=2&&(brett[i+1][j+2][k]==0||brett[i+1][j+2][k]<7)){
                            moves[i][j][k].add(i+1,j+2,k);
                        }
                        if(i-2>=0&&i-2<=7&&j-1>=0&&j-1<=2&&(brett[i-2][j-1][k]==0||brett[i-2][j-1][k]<7)){
                            moves[i][j][k].add(i-2,j-1,k);
                        }
                        if(i-2>=0&&i-2<=7&&j+1>=0&&j+1<=2&&(brett[i-2][j+1][k]==0||brett[i-2][j+1][k]<7)){
                            moves[i][j][k].add(i-2,j+1,k);
                        }
                        if(i+2>=0&&i+2<=7&&j-1>=0&&j-1<=2&&(brett[i+2][j-1][k]==0||brett[i+2][j-1][k]<7)){
                            moves[i][j][k].add(i+2,j-1,k);
                        }
                        if(i+2>=0&&i+2<=7&&j+1>=0&&j+1<=2&&(brett[i+2][j+1][k]==0||brett[i+2][j+1][k]<7)){
                            moves[i][j][k].add(i+2,j+1,k);
                        }

                        if(k-1>=0&&k-1<=2&&j-2>=0&&j-2<=2&&(brett[i][j-2][k-1]==0||brett[i][j-2][k-1]<7)){
                            moves[i][j][k].add(i,j-2,k-1);
                        }
                        if(k-1>=0&&k-1<=2&&j+2>=0&&j+2<=2&&(brett[i][j+2][k-1]==0||brett[i][j+2][k-1]<7)){
                            moves[i][j][k].add(i,j+2,k-1);
                        }
                        if(k+1>=0&&k+1<=2&&j-2>=0&&j-2<=2&&(brett[i][j-2][k+1]==0||brett[i][j-2][k+1]<7)){
                            moves[i][j][k].add(i,j-2,k+1);
                        }
                        if(k+1>=0&&k+1<=2&&j+2>=0&&j+2<=2&&(brett[i][j+2][k+1]==0||brett[i][j+2][k+1]<7)){
                            moves[i][j][k].add(i,j+2,k+1);
                        }
                        if(i-2>=0&&i-2<=7&&k-1>=0&&k-1<=2&&(brett[i-2][j][k-1]==0||brett[i-2][j][k-1]<7)){
                            moves[i][j][k].add(i-2,j,k-1);
                        }
                        if(i-2>=0&&i-2<=7&&k+1>=0&&k+1<=2&&(brett[i-2][j][k+1]==0||brett[i-2][j][k+1]<7)){
                            moves[i][j][k].add(i-2,j,k+1);
                        }
                        if(i+2>=0&&i+2<=7&&k-1>=0&&k-1<=2&&(brett[i+2][j][k-1]==0||brett[i+2][j][k-1]<7)){
                            moves[i][j][k].add(i+2,j,k-1);
                        }
                        if(i+2>=0&&i+2<=7&&k+1>=0&&k+1<=2&&(brett[i+2][j][k+1]==0||brett[i+2][j][k+1]<7)){
                            moves[i][j][k].add(i+2,j,k+1);
                        }

                        if(k-2>=0&&k-2<=2&&j-1>=0&&j-1<=2&&(brett[i][j-1][k-2]==0||brett[i][j-1][k-2]<7)){
                            moves[i][j][k].add(i,j-1,k-2);
                        }
                        if(k-2>=0&&k-2<=2&&j+1>=0&&j+1<=2&&(brett[i][j+1][k-2]==0||brett[i][j+1][k-2]<7)){
                            moves[i][j][k].add(i,j+1,k-2);
                        }
                        if(k+2>=0&&k+2<=2&&j-1>=0&&j-1<=2&&(brett[i][j-1][k+2]==0||brett[i][j-1][k+2]<7)){
                            moves[i][j][k].add(i,j-1,k+2);
                        }
                        if(k+2>=0&&k+2<=2&&j+1>=0&&j+1<=2&&(brett[i][j+1][k+2]==0||brett[i][j+1][k+2]<7)){
                            moves[i][j][k].add(i,j+1,k+2);
                        }
                        if(i-1>=0&&i-1<=7&&k-2>=0&&k-2<=2&&(brett[i-1][j][k-2]==0||brett[i-1][j][k-2]<7)){
                            moves[i][j][k].add(i-1,j,k-2);
                        }
                        if(i-1>=0&&i-1<=7&&k+2>=0&&k+2<=2&&(brett[i-1][j][k+2]==0||brett[i-1][j][k+2]<7)){
                            moves[i][j][k].add(i-1,j,k+2);
                        }
                        if(i+1>=0&&i+1<=7&&k-2>=0&&k-2<=2&&(brett[i+1][j][k-2]==0||brett[i+1][j][k-2]<7)){
                            moves[i][j][k].add(i+1,j,k-2);
                        }
                        if(i+1>=0&&i+1<=7&&k+2>=0&&k+2<=2&&(brett[i+1][j][k+2]==0||brett[i+1][j][k+2]<7)){
                            moves[i][j][k].add(i+1,j,k+2);
                        }
                    }
                    else if(brett[i][j][k]==9){
                        boolean running=true;
                        int bx=i+1;
                        int by=j+1;
                        int bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }

                        running=true;
                        bx=i+1;
                        by=j+1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                                bz=bz+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }


                        running=true;
                        bx=i+1;
                        by=j+1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                                bz=bz-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                    }
                    else if(brett[i][j][k]==10){
                        boolean running=true;
                        int bx=i+1;
                        int by=j;
                        int bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j+1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }

                        running=true;
                        bx=i;
                        by=j;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                    }
                    else if(brett[i][j][k]==11){
                        boolean running=true;
                        int bx=i+1;
                        int by=j+1;
                        int bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }

                        running=true;
                        bx=i+1;
                        by=j+1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                                bz=bz+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }


                        running=true;
                        bx=i+1;
                        by=j+1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by+1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j-1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by-1;
                                bz=bz-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j+1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                                by=by+1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i+1;
                        by=j-1;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                                by=by-1;
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }

                        running=true;
                        bx=i+1;
                        by=j;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i-1;
                        by=j;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bx=bx-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j+1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                by=by+1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j-1;
                        bz=k;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                by=by-1;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }

                        running=true;
                        bx=i;
                        by=j;
                        bz=k-1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz>=0&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bz--;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz>=0&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                        running=true;
                        bx=i;
                        by=j;
                        bz=k+1;
                        while(running){
                            if(bx>=0&&bx<8&&by>=0&&by<3&&bz<3&&brett[bx][by][bz]==0){
                                moves[i][j][k].add(bx,by,bz);
                                bz++;
                            }
                            else if(bx>=0&&by>=0&&bx<8&&by<3&&bz<3&&brett[bx][by][bz]<7){
                                moves[i][j][k].add(bx,by,bz);
                                running=false;
                            }
                            else{
                                running=false;
                            }
                        }
                    }
                    else if(brett[i][j][k]==12){
                        if(i+1>=0&&i+1<=7&&j+1>=0&&j+1<=2&&(brett[i+1][j+1][k]==0||brett[i+1][j+1][k]<7)){
                            moves[i][j][k].add(i+1,j+1,k);
                        }
                        if(i+1>=0&&i+1<=7&&j-1>=0&&j-1<=2&&(brett[i+1][j-1][k]==0||brett[i+1][j-1][k]<7)){
                            moves[i][j][k].add(i+1,j-1,k);
                        }
                        if(i+1>=0&&i+1<=7&&j>=0&&j<=2&&(brett[i+1][j][k]==0||brett[i+1][j][k]<7)){
                            moves[i][j][k].add(i+1,j,k);
                        }
                        if(i>=0&&i<=7&&j+1>=0&&j+1<=2&&(brett[i][j+1][k]==0||brett[i][j+1][k]<7)){
                            moves[i][j][k].add(i,j+1,k);
                        }
                        if(i>=0&&i<=7&&j-1>=0&&j-1<=2&&(brett[i][j-1][k]==0||brett[i][j-1][k]<7)){
                            moves[i][j][k].add(i,j-1,k);
                        }
                        if(i-1>=0&&i-1<=7&&j+1>=0&&j+1<=2&&(brett[i-1][j+1][k]==0||brett[i-1][j+1][k]<7)){
                            moves[i][j][k].add(i-1,j+1,k);
                        }
                        if(i-1>=0&&i-1<=7&&j-1>=0&&j-1<=2&&(brett[i-1][j-1][k]==0||brett[i-1][j-1][k]<7)){
                            moves[i][j][k].add(i-1,j-1,k);
                        }
                        if(i-1>=0&&i-1<=7&&j>=0&&j<=2&&(brett[i-1][j][k]==0||brett[i-1][j][k]<7)){
                            moves[i][j][k].add(i-1,j,k);
                        }

                        if(i+1>=0&&i+1<=7&&j+1>=0&&j+1<=2&&k+1<3&&(brett[i+1][j+1][k+1]==0||brett[i+1][j+1][k+1]<7)){
                            moves[i][j][k].add(i+1,j+1,k+1);
                        }
                        if(i+1>=0&&i+1<=7&&j-1>=0&&j-1<=2&&k+1<3&&(brett[i+1][j-1][k+1]==0||brett[i+1][j-1][k+1]<7)){
                            moves[i][j][k].add(i+1,j-1,k+1);
                        }
                        if(i+1>=0&&i+1<=7&&j>=0&&j<=2&&k+1<3&&(brett[i+1][j][k+1]==0||brett[i+1][j][k+1]<7)){
                            moves[i][j][k].add(i+1,j,k+1);
                        }
                        if(i>=0&&i<=7&&j+1>=0&&j+1<=2&&k+1<3&&(brett[i][j+1][k+1]==0||brett[i][j+1][k+1]<7)){
                            moves[i][j][k].add(i,j+1,k+1);
                        }
                        if(i>=0&&i<=7&&j-1>=0&&j-1<=2&&k+1<3&&(brett[i][j-1][k+1]==0||brett[i][j-1][k+1]<7)){
                            moves[i][j][k].add(i,j-1,k+1);
                        }
                        if(i-1>=0&&i-1<=7&&j+1>=0&&j+1<=2&&k+1<3&&(brett[i-1][j+1][k+1]==0||brett[i-1][j+1][k+1]<7)){
                            moves[i][j][k].add(i-1,j+1,k+1);
                        }
                        if(i-1>=0&&i-1<=7&&j-1>=0&&j-1<=2&&k+1<3&&(brett[i-1][j-1][k+1]==0||brett[i-1][j-1][k+1]<7)){
                            moves[i][j][k].add(i-1,j-1,k+1);
                        }
                        if(i-1>=0&&i-1<=7&&j>=0&&j<=2&&k+1<3&&(brett[i-1][j][k+1]==0||brett[i-1][j][k+1]<7)){
                            moves[i][j][k].add(i-1,j,k+1);
                        }

                        if(i+1>=0&&i+1<=7&&j+1>=0&&j+1<=2&&k-1>=0&&(brett[i+1][j+1][k-1]==0||brett[i+1][j+1][k-1]<7)){
                            moves[i][j][k].add(i+1,j+1,k-1);
                        }
                        if(i+1>=0&&i+1<=7&&j-1>=0&&j-1<=2&&k-1>=0&&(brett[i+1][j-1][k-1]==0||brett[i+1][j-1][k-1]<7)){
                            moves[i][j][k].add(i+1,j-1,k-1);
                        }
                        if(i+1>=0&&i+1<=7&&j>=0&&j<=2&&k-1>=0&&(brett[i+1][j][k-1]==0||brett[i+1][j][k-1]<7)){
                            moves[i][j][k].add(i+1,j,k-1);
                        }
                        if(i>=0&&i<=7&&j+1>=0&&j+1<=2&&k-1>=0&&(brett[i][j+1][k-1]==0||brett[i][j+1][k-1]<7)){
                            moves[i][j][k].add(i,j+1,k-1);
                        }
                        if(i>=0&&i<=7&&j-1>=0&&j-1<=2&&k-1>=0&&(brett[i][j-1][k-1]==0||brett[i][j-1][k-1]<7)){
                            moves[i][j][k].add(i,j-1,k-1);
                        }
                        if(i-1>=0&&i-1<=7&&j+1>=0&&j+1<=2&&k-1>=0&&(brett[i-1][j+1][k-1]==0||brett[i-1][j+1][k-1]<7)){
                            moves[i][j][k].add(i-1,j+1,k-1);
                        }
                        if(i-1>=0&&i-1<=7&&j-1>=0&&j-1<=2&&k-1>=0&&(brett[i-1][j-1][k-1]==0||brett[i-1][j-1][k-1]<7)){
                            moves[i][j][k].add(i-1,j-1,k-1);
                        }
                        if(i-1>=0&&i-1<=7&&j>=0&&j<=2&&k-1>=0&&(brett[i-1][j][k-1]==0||brett[i-1][j][k-1]<7)){
                            moves[i][j][k].add(i-1,j,k-1);
                        }
                    }
                }
            }
            }
        }
    }
}
class Moves{
    int[]x=new int[0];
    int[]y=new int[0];
    int[]z=new int[0];
    public Moves(){
    }
    public void add(int a,int b,int c){
        int n=x.length;
        int[]x2=new int[n+1];
        int[]y2=new int[n+1];
        int[]z2=new int[n+1];
        for(int i=0;i<n;i++){
            x2[i]=x[i];
            y2[i]=y[i];
            z2[i]=z[i];
        }
        x2[n]=a;
        y2[n]=b;
        z2[n]=c;
        x=x2;
        y=y2;
        z=z2;
    }
}
class SchachFrame extends Frame implements Runnable{
    Engine eng;
    Schachbrett schach;
    Thread t;
    Image bauer1;
    Image springer1;
    Image laeufer1;
    Image turm1;
    Image dame1;
    Image koenig1;
    Image bauer2;
    Image springer2;
    Image laeufer2;
    Image turm2;
    Image dame2;
    Image koenig2;
    Image black;
    Image white;
    Image selected;
    Group[][][]figures=new Group[8][3][3];
    Group[][][]bfigures=new Group[8][3][3];
    Group selgroup;
    int xpos=0;
    int ypos=0;
    int zpos=0;
    boolean running=true;
    boolean sel=false;
    boolean mov=false;
    int sx=0;
    int sy=0;
    int sz=0;
    double cx=0;
    double cy=-Math.PI/4;
    double wx=0;
    double wy=0;
    double entf=300;
    double xp=0;
    double yp=0;
    double zp=0;
    boolean movemode=false;
    Towers tow;
    public SchachFrame(Schachbrett schach,Towers tow){
        super("Astro Solutions Schach");
        if(schach.curnum==0){
            setTitle("Astro Solutions Schach YOU: WHITE");
        }
        else{
            setTitle("Astro Solutions Schach YOU: BLACK");
        }
//System.out.println("a1");
        pack();
        resize(640,480);
        setLayout(null);
        this.schach=schach;
        this.tow=tow;
        eng=new Engine();
        add(eng);
        eng.reshape(0,0,640,480);
        addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent w){hide();}});
//System.out.println("a5");
        try{
            bauer1=getToolkit().getImage("bauer1.gif");
            springer1=getToolkit().getImage("springer1.gif");
            laeufer1=getToolkit().getImage("laeufer1.gif");
            turm1=getToolkit().getImage("turm1.gif");
            dame1=getToolkit().getImage("dame1.gif");
            koenig1=getToolkit().getImage("koenig1.gif");
            bauer2=getToolkit().getImage("bauer2.gif");
            springer2=getToolkit().getImage("springer2.gif");
            laeufer2=getToolkit().getImage("laeufer2.gif");
            turm2=getToolkit().getImage("turm2.gif");
            dame2=getToolkit().getImage("dame2.gif");
            koenig2=getToolkit().getImage("koenig2.gif");
            black=getToolkit().getImage("black.gif");
            white=getToolkit().getImage("white.gif");
            selected=getToolkit().getImage("selected.gif");
        }
        catch(Exception e){
//System.out.println("error: "+e);
        }
//System.out.println("a6");
        initbrett();
//System.out.println("a7");
        show();
        t=new Thread(this);
        t.start();
    }
    public void run(){
                    cy=cy+Math.PI/2;
                    xp=entf*Math.sin(cy)*Math.cos(cx);
                    yp=entf*Math.sin(cy)*Math.sin(cx);
                    zp=entf*Math.cos(cy);
                    wx=cx;
                    wy=cy;
                    cy=cy-Math.PI/2;
                    eng.setCam(new Vektor(-(int)xp+xpos*40,-(int)yp+ypos*40,-(int)zp-zpos*40),(float)wx,(float)wy);

        while(running){
            try{
                Thread.sleep(100);
                int code=eng.getKeyCode();
                if(code==KeyEvent.VK_DELETE){
                    if(movemode){
                        movemode=false;
                        setTitle("select figure");
                    }
                    else{
                        movemode=true;
                        setTitle("move camera");
                    }
//System.out.println("movemode: "+movemode);
                }
                if(code!=0&&movemode){
                    if(code==KeyEvent.VK_RIGHT){
                        cx=cx-Math.PI/30;
                    }
                    else if(code==KeyEvent.VK_LEFT){
                        cx=cx+Math.PI/30;
                    }
                    else if(code==KeyEvent.VK_UP){
                        cy=cy-Math.PI/30;
                    }
                    else if(code==KeyEvent.VK_DOWN){
                        cy=cy+Math.PI/30;
                    }
                    cy=cy+Math.PI/2;
                    xp=entf*Math.sin(cy)*Math.cos(cx);
                    yp=entf*Math.sin(cy)*Math.sin(cx);
                    zp=entf*Math.cos(cy);
                    wx=cx;
                    wy=cy;
                    cy=cy-Math.PI/2;
                    eng.setCam(new Vektor(-(int)xp+xpos*40,-(int)yp+ypos*40,-(int)zp-zpos*40),(float)wx,(float)wy);
                }
                if(code!=0&&!movemode){
                    if(code==KeyEvent.VK_DOWN){
                        if(xpos>0){
                            xpos=xpos-1;
                            selgroup.transform(-40,0,0);
                    cy=cy+Math.PI/2;
                    xp=entf*Math.sin(cy)*Math.cos(cx);
                    yp=entf*Math.sin(cy)*Math.sin(cx);
                    zp=entf*Math.cos(cy);
                    wx=cx;
                    wy=cy;
                    cy=cy-Math.PI/2;
                    eng.setCam(new Vektor(-(int)xp+xpos*40,-(int)yp+ypos*40,-(int)zp-zpos*40),(float)wx,(float)wy);
                        }
                    }
                    else if(code==KeyEvent.VK_LEFT){
                        if(ypos>0){
                            ypos=ypos-1;
                            selgroup.transform(0,-40,0);
                    cy=cy+Math.PI/2;
                    xp=entf*Math.sin(cy)*Math.cos(cx);
                    yp=entf*Math.sin(cy)*Math.sin(cx);
                    zp=entf*Math.cos(cy);
                    wx=cx;
                    wy=cy;
                    cy=cy-Math.PI/2;
                    eng.setCam(new Vektor(-(int)xp+xpos*40,-(int)yp+ypos*40,-(int)zp-zpos*40),(float)wx,(float)wy);
                        }
                    }
                    else if(code==KeyEvent.VK_UP){
                        if(xpos<7){
                            xpos=xpos+1;
                            selgroup.transform(40,0,0);
                    cy=cy+Math.PI/2;
                    xp=entf*Math.sin(cy)*Math.cos(cx);
                    yp=entf*Math.sin(cy)*Math.sin(cx);
                    zp=entf*Math.cos(cy);
                    wx=cx;
                    wy=cy;
                    cy=cy-Math.PI/2;
                    eng.setCam(new Vektor(-(int)xp+xpos*40,-(int)yp+ypos*40,-(int)zp-zpos*40),(float)wx,(float)wy);
                        }
                    }
                    else if(code==KeyEvent.VK_RIGHT){
                        if(ypos<2){
                            ypos=ypos+1;
                            selgroup.transform(0,40,0);
                    cy=cy+Math.PI/2;
                    xp=entf*Math.sin(cy)*Math.cos(cx);
                    yp=entf*Math.sin(cy)*Math.sin(cx);
                    zp=entf*Math.cos(cy);
                    wx=cx;
                    wy=cy;
                    cy=cy-Math.PI/2;
                    eng.setCam(new Vektor(-(int)xp+xpos*40,-(int)yp+ypos*40,-(int)zp-zpos*40),(float)wx,(float)wy);
                        }
                    }
                    else if(code==KeyEvent.VK_F1){
                        if(zpos<2){
                            zpos=zpos+1;
                            selgroup.transform(0,0,-40);
                    cy=cy+Math.PI/2;
                    xp=entf*Math.sin(cy)*Math.cos(cx);
                    yp=entf*Math.sin(cy)*Math.sin(cx);
                    zp=entf*Math.cos(cy);
                    wx=cx;
                    wy=cy;
                    cy=cy-Math.PI/2;
                    eng.setCam(new Vektor(-(int)xp+xpos*40,-(int)yp+ypos*40,-(int)zp-zpos*40),(float)wx,(float)wy);
                        }
                    }
                    else if(code==KeyEvent.VK_F2){
                        if(zpos>0){
                            zpos=zpos-1;
                            selgroup.transform(0,0,40);
                    cy=cy+Math.PI/2;
                    xp=entf*Math.sin(cy)*Math.cos(cx);
                    yp=entf*Math.sin(cy)*Math.sin(cx);
                    zp=entf*Math.cos(cy);
                    wx=cx;
                    wy=cy;
                    cy=cy-Math.PI/2;
                    eng.setCam(new Vektor(-(int)xp+xpos*40,-(int)yp+ypos*40,-(int)zp-zpos*40),(float)wx,(float)wy);
                        }
                    }
                    else if(code==KeyEvent.VK_ENTER&&!mov){
//System.out.println(" "+schach.curnum+" "+sel);
                        if(schach.curnum==0){
                            if(!sel){
                                schach.getMoves();
//System.out.println("param "+schach.brett[xpos][ypos]+" "+schach.moves[xpos][ypos].x.length);
                                if(schach.brett[xpos][ypos][zpos]>0&&schach.brett[xpos][ypos][zpos]<7&&schach.moves[xpos][ypos][zpos].x.length>0){
                                    sel=true;
                                    sx=xpos;
                                    sy=ypos;
                                    sz=zpos;
                                    setTitle("figure selected");
                                }
                                else{
                                    setTitle("select your figure error");
                                }
                            }
                            else{
                                if(!mov){
//System.out.println("a");
                                    if(schach.isMove(sx,sy,sz,xpos,ypos,zpos)){
//System.out.println("b");
                                        Schachbrett schach2=schach.copy();
//System.out.println("c");
                                        schach2.brett[xpos][ypos][zpos]=schach2.brett[sx][sy][sz];
                                        int typ=schach2.brett[xpos][ypos][zpos];
                                        schach2.brett[sx][sy][sz]=0;
                                        schach2.getMoves();
//System.out.println("d");
                                        if(schach2.checkp1()){
                                            sel=false;
                                            setTitle("you are in check");
                                        }
                                        else{
//System.out.println("mov");
                                            mov=true;
                                            schach=schach2;
                                            setTitle("moved");
                                            figures[sx][sy][sz].transform((xpos-sx)*40,(ypos-sy)*40,(zpos-sz)*40);
                                            if(figures[xpos][ypos][zpos]!=null){
                                                eng.remove(figures[xpos][ypos][zpos]);
                                            }
                                            figures[xpos][ypos][zpos]=figures[sx][sy][sz];
                                            figures[sx][sy][sz]=null;
                                            if(typ==1&&xpos==7){
                                                eng.remove(figures[xpos][ypos][zpos]);
                                                schach.brett[xpos][ypos][zpos]=5;
                Vektor v1=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-5);
                Vektor v2=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-5);
                Vektor v3=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-5);
                Vektor v4=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-5);
                Vektor v5=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-35);
                Vektor v6=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-35);
                Vektor v7=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-35);
                Vektor v8=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-35);
                Vektor v9=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-5);
                Vektor v10=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-5);
                Vektor v11=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-35);
                Vektor v12=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-35);
                Vektor v13=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-5);
                Vektor v14=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-5);
                Vektor v15=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-35);
                Vektor v16=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-35);
                Vektor v17=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-5);
                Vektor v18=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-5);
                Vektor v19=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-35);
                Vektor v20=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-35);
                Vektor v21=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-5);
                Vektor v22=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-5);
                Vektor v23=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-35);
                Vektor v24=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-35);
                Polygon p1=null;
                Polygon p2=null;
                Polygon p3=null;
                Polygon p4=null;
                Polygon p5=null;
                Polygon p6=null;
                    p1=new Polygon(v1,v2,v3,v4,dame1);
                    p2=new Polygon(v5,v6,v7,v8,dame1);
                    p3=new Polygon(v9,v10,v11,v12,dame1);
                    p4=new Polygon(v13,v14,v15,v16,dame1);
                    p5=new Polygon(v17,v18,v19,v20,dame1);
                    p6=new Polygon(v21,v22,v23,v24,dame1);
figures[xpos][ypos][zpos]=new Group();
figures[xpos][ypos][zpos].add(p1);
figures[xpos][ypos][zpos].add(p2);
figures[xpos][ypos][zpos].add(p3);
figures[xpos][ypos][zpos].add(p4);
figures[xpos][ypos][zpos].add(p5);
figures[xpos][ypos][zpos].add(p6);
eng.add(figures[xpos][ypos][zpos]);
                                            }
                                            String target=schach.player1;
                                            schach.curnum=(schach.curnum+1)%2;
                                            if(schach.curnum==1){
                                                target=schach.player2;
                                            }
                                            String mstr=schach.getString();
                                            new MailSender(target,mstr,tow);
                                        }
                                    }
                                    else{
                                        setTitle("irregular move: select other target for the same figure");
                                    }
                                }
                                else{
                                    setTitle("already moved");
                                }
                            }
                        }
                        else{
                            if(!sel){
                                schach.getMoves();
                                if(schach.brett[xpos][ypos][zpos]>6&&schach.brett[xpos][ypos][zpos]<13&&schach.moves[xpos][ypos][zpos].x.length>0){
                                    sel=true;
                                    sx=xpos;
                                    sy=ypos;
                                    setTitle("figure selected");
                                }
                                else{
                                    setTitle("select your figure");
                                }
                            }
                            else{
                                if(!mov){
                                    if(schach.isMove(sx,sy,sz,xpos,ypos,zpos)){
                                        Schachbrett schach2=schach.copy();
                                        schach2.brett[xpos][ypos][zpos]=schach2.brett[sx][sy][sz];
                                        schach2.brett[sx][sy][sz]=0;
                                        int typ=schach2.brett[xpos][ypos][zpos];
                                        schach2.getMoves();
                                        if(schach2.checkp2()){
                                            sel=false;
                                            setTitle("you are in check");
                                        }
                                        else{
                                            mov=true;
                                            schach=schach2;
                                            setTitle("moved");
                                            figures[sx][sy][sz].transform((xpos-sx)*40,(ypos-sy)*40,(zpos-sz)*40);
                                            if(figures[xpos][ypos][zpos]!=null){
                                                eng.remove(figures[xpos][ypos][zpos]);
                                            }
                                            figures[xpos][ypos][zpos]=figures[sx][sy][sz];
                                            figures[sx][sy][sz]=null;
                                            if(typ==7&&xpos==0){
                                                eng.remove(figures[xpos][ypos][zpos]);
                                                schach.brett[xpos][ypos][zpos]=11;
                Vektor v1=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-5);
                Vektor v2=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-5);
                Vektor v3=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-5);
                Vektor v4=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-5);
                Vektor v5=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-35);
                Vektor v6=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-35);
                Vektor v7=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-35);
                Vektor v8=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-35);
                Vektor v9=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-5);
                Vektor v10=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-5);
                Vektor v11=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-35);
                Vektor v12=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-35);
                Vektor v13=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-5);
                Vektor v14=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-5);
                Vektor v15=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-35);
                Vektor v16=new Vektor(xpos*40+5,ypos*40+5,-zpos*40-35);
                Vektor v17=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-5);
                Vektor v18=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-5);
                Vektor v19=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-35);
                Vektor v20=new Vektor(xpos*40+5,ypos*40+35,-zpos*40-35);
                Vektor v21=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-5);
                Vektor v22=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-5);
                Vektor v23=new Vektor(xpos*40+35,ypos*40+35,-zpos*40-35);
                Vektor v24=new Vektor(xpos*40+35,ypos*40+5,-zpos*40-35);
                Polygon p1=null;
                Polygon p2=null;
                Polygon p3=null;
                Polygon p4=null;
                Polygon p5=null;
                Polygon p6=null;
                    p1=new Polygon(v1,v2,v3,v4,dame2);
                    p2=new Polygon(v5,v6,v7,v8,dame2);
                    p3=new Polygon(v9,v10,v11,v12,dame2);
                    p4=new Polygon(v13,v14,v15,v16,dame2);
                    p5=new Polygon(v17,v18,v19,v20,dame2);
                    p6=new Polygon(v21,v22,v23,v24,dame2);
figures[xpos][ypos][zpos]=new Group();
figures[xpos][ypos][zpos].add(p1);
figures[xpos][ypos][zpos].add(p2);
figures[xpos][ypos][zpos].add(p3);
figures[xpos][ypos][zpos].add(p4);
figures[xpos][ypos][zpos].add(p5);
figures[xpos][ypos][zpos].add(p6);
eng.add(figures[xpos][ypos][zpos]);
                                            }
                                            String target=schach.player1;
                                            schach.curnum=(schach.curnum+1)%2;
                                            if(schach.curnum==1){
                                                target=schach.player2;
                                            }
                                            String mstr=schach.getString();
                                            new MailSender(target,mstr,tow);
                                        }
                                    }
                                    else{
                                        setTitle("irregular move: select other target for the same figure");
                                    }
                                }
                                else{
                                    setTitle("already moved");
                                }
                            }
                        }
                    }
                }
                while(code!=0){
                    code=eng.getKeyCode();
                }
                Thread.sleep(100);
                while(eng.getKeyCode()!=0){
                }
            }
            catch(Exception e){
                System.out.println("frame error: "+e);
            }
        }
    }
    public void initbrett(){
        int wcount=0;
        for(int i=0;i<8;i++){
            for(int j=0;j<3;j++){
                for(int k=0;k<3;k++){
                Vektor v1=new Vektor(i*40+5,j*40+5,-k*40-5);
                Vektor v2=new Vektor(i*40+35,j*40+5,-k*40-5);
                Vektor v3=new Vektor(i*40+35,j*40+35,-k*40-5);
                Vektor v4=new Vektor(i*40+5,j*40+35,-k*40-5);
                Vektor v5=new Vektor(i*40+5,j*40+5,-k*40-35);
                Vektor v6=new Vektor(i*40+35,j*40+5,-k*40-35);
                Vektor v7=new Vektor(i*40+35,j*40+35,-k*40-35);
                Vektor v8=new Vektor(i*40+5,j*40+35,-k*40-35);
                Vektor v9=new Vektor(i*40+5,j*40+5,-k*40-5);
                Vektor v10=new Vektor(i*40+35,j*40+5,-k*40-5);
                Vektor v11=new Vektor(i*40+35,j*40+5,-k*40-35);
                Vektor v12=new Vektor(i*40+5,j*40+5,-k*40-35);
                Vektor v13=new Vektor(i*40+5,j*40+5,-k*40-5);
                Vektor v14=new Vektor(i*40+5,j*40+35,-k*40-5);
                Vektor v15=new Vektor(i*40+5,j*40+35,-k*40-35);
                Vektor v16=new Vektor(i*40+5,j*40+5,-k*40-35);
                Vektor v17=new Vektor(i*40+5,j*40+35,-k*40-5);
                Vektor v18=new Vektor(i*40+35,j*40+35,-k*40-5);
                Vektor v19=new Vektor(i*40+35,j*40+35,-k*40-35);
                Vektor v20=new Vektor(i*40+5,j*40+35,-k*40-35);
                Vektor v21=new Vektor(i*40+35,j*40+5,-k*40-5);
                Vektor v22=new Vektor(i*40+35,j*40+35,-k*40-5);
                Vektor v23=new Vektor(i*40+35,j*40+35,-k*40-35);
                Vektor v24=new Vektor(i*40+35,j*40+5,-k*40-35);
                Image img=null;
                Polygon p1=null;
                Polygon p2=null;
                Polygon p3=null;
                Polygon p4=null;
                Polygon p5=null;
                Polygon p6=null;
                int[][][]brett=schach.brett;
//System.out.println(""+brett[i][j]);
//System.out.println(bauer1);
                if(brett[i][j][k]==1){
                    p1=new Polygon(v1,v2,v3,v4,bauer1);
                    p2=new Polygon(v5,v6,v7,v8,bauer1);
                    p3=new Polygon(v9,v10,v11,v12,bauer1);
                    p4=new Polygon(v13,v14,v15,v16,bauer1);
                    p5=new Polygon(v17,v18,v19,v20,bauer1);
                    p6=new Polygon(v21,v22,v23,v24,bauer1);
                }
                else if(brett[i][j][k]==2){
                    p1=new Polygon(v1,v2,v3,v4,springer1);
                    p2=new Polygon(v5,v6,v7,v8,springer1);
                    p3=new Polygon(v9,v10,v11,v12,springer1);
                    p4=new Polygon(v13,v14,v15,v16,springer1);
                    p5=new Polygon(v17,v18,v19,v20,springer1);
                    p6=new Polygon(v21,v22,v23,v24,springer1);
                }
                else if(brett[i][j][k]==3){
                    p1=new Polygon(v1,v2,v3,v4,laeufer1);
                    p2=new Polygon(v5,v6,v7,v8,laeufer1);
                    p3=new Polygon(v9,v10,v11,v12,laeufer1);
                    p4=new Polygon(v13,v14,v15,v16,laeufer1);
                    p5=new Polygon(v17,v18,v19,v20,laeufer1);
                    p6=new Polygon(v21,v22,v23,v24,laeufer1);
                }
                else if(brett[i][j][k]==4){
                    p1=new Polygon(v1,v2,v3,v4,turm1);
                    p2=new Polygon(v5,v6,v7,v8,turm1);
                    p3=new Polygon(v9,v10,v11,v12,turm1);
                    p4=new Polygon(v13,v14,v15,v16,turm1);
                    p5=new Polygon(v17,v18,v19,v20,turm1);
                    p6=new Polygon(v21,v22,v23,v24,turm1);
                }
                else if(brett[i][j][k]==5){
                    p1=new Polygon(v1,v2,v3,v4,dame1);
                    p2=new Polygon(v5,v6,v7,v8,dame1);
                    p3=new Polygon(v9,v10,v11,v12,dame1);
                    p4=new Polygon(v13,v14,v15,v16,dame1);
                    p5=new Polygon(v17,v18,v19,v20,dame1);
                    p6=new Polygon(v21,v22,v23,v24,dame1);
                }
                else if(brett[i][j][k]==6){
                    p1=new Polygon(v1,v2,v3,v4,koenig1);
                    p2=new Polygon(v5,v6,v7,v8,koenig1);
                    p3=new Polygon(v9,v10,v11,v12,koenig1);
                    p4=new Polygon(v13,v14,v15,v16,koenig1);
                    p5=new Polygon(v17,v18,v19,v20,koenig1);
                    p6=new Polygon(v21,v22,v23,v24,koenig1);
                }
                else if(brett[i][j][k]==7){
//System.out.println("bauer2"+bauer2);
                    p1=new Polygon(v1,v2,v3,v4,bauer2);
                    p2=new Polygon(v5,v6,v7,v8,bauer2);
                    p3=new Polygon(v9,v10,v11,v12,bauer2);
                    p4=new Polygon(v13,v14,v15,v16,bauer2);
                    p5=new Polygon(v17,v18,v19,v20,bauer2);
                    p6=new Polygon(v21,v22,v23,v24,bauer2);
//System.out.println("bauer2b");
                }
                else if(brett[i][j][k]==8){
                    p1=new Polygon(v1,v2,v3,v4,springer2);
                    p2=new Polygon(v5,v6,v7,v8,springer2);
                    p3=new Polygon(v9,v10,v11,v12,springer2);
                    p4=new Polygon(v13,v14,v15,v16,springer2);
                    p5=new Polygon(v17,v18,v19,v20,springer2);
                    p6=new Polygon(v21,v22,v23,v24,springer2);
                }
                else if(brett[i][j][k]==9){
//System.out.println("abc1"+laeufer2);
                    p1=new Polygon(v1,v2,v3,v4,laeufer2);
//System.out.println("abc2");
                    p2=new Polygon(v5,v6,v7,v8,laeufer2);
                    p3=new Polygon(v9,v10,v11,v12,laeufer2);
                    p4=new Polygon(v13,v14,v15,v16,laeufer2);
                    p5=new Polygon(v17,v18,v19,v20,laeufer2);
                    p6=new Polygon(v21,v22,v23,v24,laeufer2);
//System.out.println("abc");
                }
                else if(brett[i][j][k]==10){
                    p1=new Polygon(v1,v2,v3,v4,turm2);
                    p2=new Polygon(v5,v6,v7,v8,turm2);
                    p3=new Polygon(v9,v10,v11,v12,turm2);
                    p4=new Polygon(v13,v14,v15,v16,turm2);
                    p5=new Polygon(v17,v18,v19,v20,turm2);
                    p6=new Polygon(v21,v22,v23,v24,turm2);
                }
                else if(brett[i][j][k]==11){
                    p1=new Polygon(v1,v2,v3,v4,dame2);
                    p2=new Polygon(v5,v6,v7,v8,dame2);
                    p3=new Polygon(v9,v10,v11,v12,dame2);
                    p4=new Polygon(v13,v14,v15,v16,dame2);
                    p5=new Polygon(v17,v18,v19,v20,dame2);
                    p6=new Polygon(v21,v22,v23,v24,dame2);
                }
                else if(brett[i][j][k]==12){
                    p1=new Polygon(v1,v2,v3,v4,koenig2);
                    p2=new Polygon(v5,v6,v7,v8,koenig2);
                    p3=new Polygon(v9,v10,v11,v12,koenig2);
                    p4=new Polygon(v13,v14,v15,v16,koenig2);
                    p5=new Polygon(v17,v18,v19,v20,koenig2);
                    p6=new Polygon(v21,v22,v23,v24,koenig2);
                }
                if(p1!=null&&p2!=null){
//System.out.println("a1");
                    figures[i][j][k]=new Group();
                    figures[i][j][k].add(p1);
                    figures[i][j][k].add(p2);
                    figures[i][j][k].add(p3);
                    figures[i][j][k].add(p4);
                    figures[i][j][k].add(p5);
                    figures[i][j][k].add(p6);
//System.out.println("a2 "+i+" "+j);
                }
//System.out.println("figu: "+figures[i][j]);
                if(figures[i][j][k]!=null){
                    eng.add(figures[i][j][k]);
                }
                }
                wcount=wcount+1;
//System.out.println("i: "+i+" j: "+j);
            }
            wcount=wcount+1;
        }
        selgroup=new Group();
        Vektor v1x=new Vektor(0,0,0);
        Vektor v2x=new Vektor(40,0,0);
        Vektor v3x=new Vektor(40,40,0);
        Vektor v4x=new Vektor(0,40,0);
        Vektor v1y=new Vektor(0,0,-40);
        Vektor v2y=new Vektor(40,0,-40);
        Vektor v3y=new Vektor(40,40,-40);
        Vektor v4y=new Vektor(0,40,-40);
        Polygon pol1=new Polygon(v1x,v2x,v3x,v4x,selected);
        Polygon pol2=new Polygon(v1y,v2y,v3y,v4y,selected);
        selgroup.add(pol1);
        selgroup.add(pol2);
        eng.add(selgroup);
    }
}
class MailSender implements Runnable{
    Thread t;
    String target;
    String text;
    Towers tow;
    public MailSender(String target,String text,Towers tow){
        this.target=target;
        this.text=text;
        this.tow=tow;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        try{
            int nr=tow.increase();
            FileOutputStream fos=new FileOutputStream(".\\tmp\\"+nr+".tmp");
            PrintStream ps=new PrintStream(fos);
            ps.print("From: \""+tow.username.getText()+" Schach\" <"+tow.username.getText()+">");
            fos.write(13);
            fos.write(10);
            ps.print("Subject: Schach");
            fos.write(13);
            fos.write(10);
            ps.print("MIME-Version: 1.0");
            fos.write(13);
            fos.write(10);
            ps.print("Content-Type: multipart/mixed;");
//            fos.write(13);
//            fos.write(10);
            ps.print("boundary=\"bounds\"");
            fos.write(13);
            fos.write(10);
            ps.print("X-Priority: 3");
            fos.write(13);
            fos.write(10);
            ps.print("X-MSMail-Priority: Normal");
            fos.write(13);
            fos.write(10);
            ps.print("X-Unsent: 1");
            fos.write(13);
            fos.write(10);
            fos.write(13);
            fos.write(10);
            ps.print("--bounds");
            fos.write(13);
            fos.write(10);
            ps.print("Content-Type: text/plain;");
//            fos.write(13);
//            fos.write(10);
            ps.print("charset=\"utf-8\"");
//            fos.write(13);
//            fos.write(10);
//            ps.print("Content-Transfer-Encoding: quotable-printable");
            fos.write(13);
            fos.write(10);
            fos.write(13);
            fos.write(10);
            ps.print(text+"\r\n");
            fos.write(13);
            fos.write(10);
            fos.write(13);
            fos.write(10);
            ps.print("--bounds");
            fos.write(13);
            fos.write(10);
//            fos.write(13);
//            fos.write(10);
//            ps.print("--bounds");
//            fos.write(13);
//            fos.write(10);
            ps.print("Content-Type: application/octet-stream;");
//            fos.write(13);
//            fos.write(10);
              ps.print("name=\"partie.tow"+"\"");
            fos.write(13);
            fos.write(10);
//            ps.print("charset=\"iso-8859-1\"");
//            fos.write(13);
//            fos.write(10);
            ps.print("Content-Transfer-Encoding: base64");
            fos.write(13);
            fos.write(10);
                ps.print("Content-Disposition: attachment; filename=\"partie.tow"+"\"");
            fos.write(13);
            fos.write(10);
            fos.write(13);
            fos.write(10);
            convert("\r\n\r\n\r\n"+text,fos,ps);
            fos.write(13);
            fos.write(10);
            fos.write(13);
            fos.write(10);
            ps.print("--bounds--");
            fos.write(13);
            fos.write(10);
            ps.close();
            fos.close();
            tow.info.setText("mail created...connect to mailserver");
//System.out.println("twm: "+tow.mailserver.getText());
            Socket so=new Socket(tow.mailserver.getText(),25);
//System.out.println("ok");
            InputStream isb=so.getInputStream();
            DataInputStream disb=new DataInputStream(isb);
            OutputStream osb=so.getOutputStream();
            PrintStream psb=new PrintStream(osb);
            String a1=disb.readLine();
            tow.info.setText(""+a1);
            psb.print("EHLO "+tow.mailserver.getText());
            osb.write(13);
            osb.write(10);
            String a2="";
            while((a2=disb.readLine())!=null&&a2.length()>3&&"-".equals(a2.substring(3,4))){
            }
            tow.info.setText(""+a2);


            psb.print("AUTH LOGIN");
            osb.write(13);
            osb.write(10);
            String ges=disb.readLine().substring(4);
            String ustr=tow.username.getText();
            int ind=ustr.indexOf("@");
//System.out.println(ustr+""+ind);
            ustr=ustr.substring(0,ind);
            String str1=base64(ustr);
            psb.print(str1);
            osb.write(13);
            osb.write(10);
            String xx=disb.readLine().substring(4);
//System.out.println("xx: "+xx);
//            String a2b=getLine(isb);
//System.out.println("a2b: "+xx+"X"+tow.password.getText());
            String str2=base64(tow.password.getText());
//System.out.println(str2);
            psb.print(str2);
            osb.write(13);
            osb.write(10);
            String a2c=disb.readLine();
//System.out.println("a2c: "+a2c);
            psb.print("MAIL FROM:<"+tow.username.getText()+">");
            osb.write(13);
            osb.write(10);
            String a3="";
            while((a3=disb.readLine())!=null&&a3.length()>3&&"-".equals(a3.substring(3,4))){
//                System.out.println(a3);
            }
//System.out.println(a3);
            tow.info.setText(""+a3);
//System.out.println("target: "+target);
            psb.print("RCPT TO:<"+target+">");
            osb.write(13);
            osb.write(10);
            String a4="";
            while((a4=disb.readLine())!=null&&a4.length()>3&&"-".equals(a4.substring(3,4))){
//                System.out.println(a4);
            }
//System.out.println("a4: "+a4);
            tow.info.setText(""+a4);
            psb.print("DATA");
            osb.write(13);
            osb.write(10);
            String a5="";
            while((a5=disb.readLine())!=null&&a5.length()>3&&"-".equals(a5.substring(3,4))){
//                System.out.println(a5);
            }
            if(a5==null||(a5!=null&&a5.length()>=0&&"4".equals(a5.substring(0,1)))){
                throw(new Exception("data send error: "+a5));
            }
//System.out.println(a5);
            tow.info.setText("sending data: "+a5);
            FileInputStream fisb=new FileInputStream(".\\tmp\\"+nr+".tmp");
            int inpb=0;
            byte[]buf=new byte[1024];
            while((inpb=fisb.read(buf,0,1024))!=-1){
//System.out.println("inp: "+inpb);
                osb.write(buf,0,inpb);
            }
            fisb.close();
            osb.write(13);
            osb.write(10);
            psb.print(".");
            osb.write(13);
            osb.write(10);
            String a6=disb.readLine();
            tow.info.setText("DATA sent: "+a6);
//System.out.println("a6: "+a6);
            psb.print("QUIT");
            osb.write(13);
            osb.write(10);
            String a7=disb.readLine();
            tow.info.setText("QUIT: "+a7);
            psb.close();
            osb.close();
            disb.close();
            isb.close();
            so.close();
            tow.info.setText("file sent!");
        }
        catch(Exception e){
            tow.info.setText("mailheader error: "+e);
        }
    }
    public void convert(String text,FileOutputStream fos,PrintStream ps){
        try{
            int n=text.length();
            int inp=0;
            int d=0;
            int b1=0;
            int b2=0;
            int b3=0;
            int fb1=0;
            int fb2=0;
            int poser=0;
            while(poser<n||d%3!=0){
                byte[]byby=new byte[1];
                if(poser<n){
                    byby=text.substring(poser,poser+1).getBytes();
                }
                poser++;
                inp=byby[0];
                int zer=0;
                if(inp==-1){
                    inp=0;
                    zer=1;
                }
                if(d==0){
                    b1=inp;
                    fb1=0;
                    fb2=0;
                }
                if(d==1){
                    b2=inp;
                    if(zer==1){
                        fb1=1;
                    }
                }
                if(d==2){
                    b3=inp;
                    if(zer==1){
                        fb2=1;
                    }
                }
                d++;
                if(d==3){
                    d=0;
                    int potenz=1;
                    int[]c1=new int[8];
                    for(int i=0;i<8;i++){
                        c1[7-i]=(b1/potenz)%2;
                        potenz=potenz*2;
                    }
                    potenz=1;
                    int[]c2=new int[8];
                    for(int i=0;i<8;i++){
                        c2[7-i]=(b2/potenz)%2;
                        potenz=potenz*2;
                    }
                    potenz=1;
                    int[]c3=new int[8];
                    for(int i=0;i<8;i++){
                        c3[7-i]=(b3/potenz)%2;
                        potenz=potenz*2;
                    }
                    int d1=c1[5]+c1[4]*2+c1[3]*2*2+c1[2]*2*2*2+c1[1]*2*2*2*2+c1[0]*2*2*2*2*2;
                    int d2=c2[3]+c2[2]*2+c2[1]*2*2+c2[0]*2*2*2+c1[7]*2*2*2*2+c1[6]*2*2*2*2*2;
                    int d3=c3[1]+c3[0]*2+c2[7]*2*2+c2[6]*2*2*2+c2[5]*2*2*2*2+c2[4]*2*2*2*2*2;
                    int d4=c3[7]+c3[6]*2+c3[5]*2*2+c3[4]*2*2*2+c3[3]*2*2*2*2+c3[2]*2*2*2*2*2;

                    if(fb1==0&&fb2==0){
                        ps.print(getChar(d1));
                        ps.print(getChar(d2));
                        ps.print(getChar(d3));
                        ps.print(getChar(d4));
                    }
                    else if(fb1==0&&fb2==1){
                        ps.print(getChar(d1));
                        ps.print(getChar(d2));
                        ps.print(getChar(d3));
                        ps.print("=");
                    }
                    else if(fb1==1&&fb2==1){
                        ps.print(getChar(d1));
                        ps.print(getChar(d2));
                        ps.print("=");
                        ps.print("=");
                    }
                }
            }
        }
        catch(Exception e){
            System.out.println("base64 error: "+e);
        }
    }
    public String getLine(InputStream isb){
        String ges="";
        try{
            boolean runi=true;
            int nine=0;
            while(runi){
                byte[]byb=new byte[4];
                byb[0]=(byte)isb.read();
                byb[1]=(byte)isb.read();
                byb[2]=(byte)isb.read();
                byb[3]=(byte)isb.read();
                int[]res=gbytes2(new String(byb));
                for(int i=0;i<3;i++){
                    byte[]bv="=".getBytes();
//System.out.println("i: "+i+" res: "+res[i]);
                    if(res[i]==10||res[i]==13||(bv[0]==(byte)res[i])){
                        runi=false;
                    }
                    else{
                        bv[0]=(byte)res[i];
                        ges=ges+new String(bv);
//System.out.println("ges: "+ges);
                    }
                }
                nine=nine+3;
                if(nine==9){
                    runi=false;
                }
            }
        }
        catch(Exception e){
            System.out.println("InputStream: "+e);
        }
        return ges;
    }
    public String base64(String base){
            int inp=0;
            int d=0;
            int b1=0;
            int b2=0;
            int b3=0;
            int fb1=0;
            int fb2=0;
            int len=base.length();
            int pos=0;
            int round=len/3;
            if(len%3==0){
                round=round*3;
            }
            else{
                round=(round+1)*3;
            }
            String ret="";
            boolean running=true;
            while(running){
                int zer=0;
                if(pos>=len){
                    inp=0;
                    zer=1;
                }
                else{
                    byte[]by=base.substring(pos,pos+1).getBytes();
                    inp=by[0];
                    if(inp<0){
                        inp=256+inp;
                    }
                }
                if(d==0){
                    b1=inp;
                    fb1=0;
                    fb2=0;
                }
                if(d==1){
                    b2=inp;
                    if(zer==1){
                        fb1=1;
                    }
                }
                if(d==2){
                    b3=inp;
                    if(zer==1){
                        fb2=1;
                    }
                }
                d++;
                if(d==3){
                    d=0;
                    int potenz=1;
                    int[]c1=new int[8];
                    for(int i=0;i<8;i++){
                        c1[7-i]=(b1/potenz)%2;
                        potenz=potenz*2;
                    }
                    potenz=1;
                    int[]c2=new int[8];
                    for(int i=0;i<8;i++){
                        c2[7-i]=(b2/potenz)%2;
                        potenz=potenz*2;
                    }
                    potenz=1;
                    int[]c3=new int[8];
                    for(int i=0;i<8;i++){
                        c3[7-i]=(b3/potenz)%2;
                        potenz=potenz*2;
                    }
                    int d1=c1[5]+c1[4]*2+c1[3]*2*2+c1[2]*2*2*2+c1[1]*2*2*2*2+c1[0]*2*2*2*2*2;
                    int d2=c2[3]+c2[2]*2+c2[1]*2*2+c2[0]*2*2*2+c1[7]*2*2*2*2+c1[6]*2*2*2*2*2;
                    int d3=c3[1]+c3[0]*2+c2[7]*2*2+c2[6]*2*2*2+c2[5]*2*2*2*2+c2[4]*2*2*2*2*2;
                    int d4=c3[7]+c3[6]*2+c3[5]*2*2+c3[4]*2*2*2+c3[3]*2*2*2*2+c3[2]*2*2*2*2*2;

                    if(fb1==0&&fb2==0){
                        ret=ret+getChar(d1);
                        ret=ret+getChar(d2);
                        ret=ret+getChar(d3);
                        ret=ret+getChar(d4);
                    }
                    else if(fb1==0&&fb2==1){
                        ret=ret+getChar(d1);
                        ret=ret+getChar(d2);
                        ret=ret+getChar(d3);
                        ret=ret+"=";
                    }
                    else if(fb1==1&&fb2==1){
                        ret=ret+getChar(d1);
                        ret=ret+getChar(d2);
                        ret=ret+"=";
                        ret=ret+"=";
                    }
                }
                pos++;
                if(pos>=round){
                    running=false;
                }
            }
            return ret;
    }
    public String getChar(int d){
        if(d==0){
            return "A";
        }
        else if(d==1){
            return "B";
        }
        else if(d==2){
            return "C";
        }
        else if(d==3){
            return "D";
        }
        else if(d==4){
            return "E";
        }
        else if(d==5){
            return "F";
        }
        else if(d==6){
            return "G";
        }
        else if(d==7){
            return "H";
        }
        else if(d==8){
            return "I";
        }
        else if(d==9){
            return "J";
        }
        else if(d==10){
            return "K";
        }
        else if(d==11){
            return "L";
        }
        else if(d==12){
            return "M";
        }
        else if(d==13){
            return "N";
        }
        else if(d==14){
            return "O";
        }
        else if(d==15){
            return "P";
        }
        else if(d==16){
            return "Q";
        }
        else if(d==17){
            return "R";
        }
        else if(d==18){
            return "S";
        }
        else if(d==19){
            return "T";
        }
        else if(d==20){
            return "U";
        }
        else if(d==21){
            return "V";
        }
        else if(d==22){
            return "W";
        }
        else if(d==23){
            return "X";
        }
        else if(d==24){
            return "Y";
        }
        else if(d==25){
            return "Z";
        }
        else if(d==26){
            return "a";
        }
        else if(d==27){
            return "b";
        }
        else if(d==28){
            return "c";
        }
        else if(d==29){
            return "d";
        }
        else if(d==30){
            return "e";
        }
        else if(d==31){
            return "f";
        }
        else if(d==32){
            return "g";
        }
        else if(d==33){
            return "h";
        }
        else if(d==34){
            return "i";
        }
        else if(d==35){
            return "j";
        }
        else if(d==36){
            return "k";
        }
        else if(d==37){
            return "l";
        }
        else if(d==38){
            return "m";
        }
        else if(d==39){
            return "n";
        }
        else if(d==40){
            return "o";
        }
        else if(d==41){
            return "p";
        }
        else if(d==42){
            return "q";
        }
        else if(d==43){
            return "r";
        }
        else if(d==44){
            return "s";
        }
        else if(d==45){
            return "t";
        }
        else if(d==46){
            return "u";
        }
        else if(d==47){
            return "v";
        }
        else if(d==48){
            return "w";
        }
        else if(d==49){
            return "x";
        }
        else if(d==50){
            return "y";
        }
        else if(d==51){
            return "z";
        }
        else if(d==52){
            return "0";
        }
        else if(d==53){
            return "1";
        }
        else if(d==54){
            return "2";
        }
        else if(d==55){
            return "3";
        }
        else if(d==56){
            return "4";
        }
        else if(d==57){
            return "5";
        }
        else if(d==58){
            return "6";
        }
        else if(d==59){
            return "7";
        }
        else if(d==60){
            return "8";
        }
        else if(d==61){
            return "9";
        }
        else if(d==62){
            return "+";
        }
        else if(d==63){
            return "/";
        }
        return "A";
    }
    public int[] gbytes2(String s){
        int a=getInt(s.substring(0,1));
        int b=getInt(s.substring(1,2));
        int c=getInt(s.substring(2,3));
        int d=getInt(s.substring(3,4));
        return gbytes(a,b,c,d);
    }
    public int[] gbytes(int a,int b,int c,int d){
        int a2=((a/32)%2)*128+((a/16)%2)*64+((a/8)%2)*32+((a/4)%2)*16+((a/2)%2)*8+((a/1)%2)*4+((b/32)%2)*2+((b/16)%2);
        int b2=((b/8)%2)*128+((b/4)%2)*64+((b/2)%2)*32+((b/1)%2)*16+((c/32)%2)*8+((c/16)%2)*4+((c/8)%2)*2+((c/4)%2);
        int c2=((c/2)%2)*128+((c/1)%2)*64+((d/32)%2)*32+((d/16)%2)*16+((d/8)%2)*8+((d/4)%2)*4+((d/2)%2)*2+((d/1)%2);
        int[]ret=new int[3];
        ret[0]=a2;
        ret[1]=b2;
        ret[2]=c2;
        return ret;
    }
    public int getInt(String s){
        if(s.equals("A")){
            return 0;
        }
        else if(s.equals("B")){
            return 1;
        }
        else if(s.equals("C")){
            return 2;
        }
        else if(s.equals("D")){
            return 3;
        }
        else if(s.equals("E")){
            return 4;
        }
        else if(s.equals("F")){
            return 5;
        }
        else if(s.equals("G")){
            return 6;
        }
        else if(s.equals("H")){
            return 7;
        }
        else if(s.equals("I")){
            return 8;
        }
        else if(s.equals("J")){
            return 9;
        }
        else if(s.equals("K")){
            return 10;
        }
        else if(s.equals("L")){
            return 11;
        }
        else if(s.equals("M")){
            return 12;
        }
        else if(s.equals("N")){
            return 13;
        }
        else if(s.equals("O")){
            return 14;
        }
        else if(s.equals("P")){
            return 15;
        }
        else if(s.equals("Q")){
            return 16;
        }
        else if(s.equals("R")){
            return 17;
        }
        else if(s.equals("S")){
            return 18;
        }
        else if(s.equals("T")){
            return 19;
        }
        else if(s.equals("U")){
            return 20;
        }
        else if(s.equals("V")){
            return 21;
        }
        else if(s.equals("W")){
            return 22;
        }
        else if(s.equals("X")){
            return 23;
        }
        else if(s.equals("Y")){
            return 24;
        }
        else if(s.equals("Z")){
            return 25;
        }
        else if(s.equals("a")){
            return 26;
        }
        else if(s.equals("b")){
            return 27;
        }
        else if(s.equals("c")){
            return 28;
        }
        else if(s.equals("d")){
            return 29;
        }
        else if(s.equals("e")){
            return 30;
        }
        else if(s.equals("f")){
            return 31;
        }
        else if(s.equals("g")){
            return 32;
        }
        else if(s.equals("h")){
            return 33;
        }
        else if(s.equals("i")){
            return 34;
        }
        else if(s.equals("j")){
            return 35;
        }
        else if(s.equals("k")){
            return 36;
        }
        else if(s.equals("l")){
            return 37;
        }
        else if(s.equals("m")){
            return 38;
        }
        else if(s.equals("n")){
            return 39;
        }
        else if(s.equals("o")){
            return 40;
        }
        else if(s.equals("p")){
            return 41;
        }
        else if(s.equals("q")){
            return 42;
        }
        else if(s.equals("r")){
            return 43;
        }
        else if(s.equals("s")){
            return 44;
        }
        else if(s.equals("t")){
            return 45;
        }
        else if(s.equals("u")){
            return 46;
        }
        else if(s.equals("v")){
            return 47;
        }
        else if(s.equals("w")){
            return 48;
        }
        else if(s.equals("x")){
            return 49;
        }
        else if(s.equals("y")){
            return 50;
        }
        else if(s.equals("z")){
            return 51;
        }
        else if(s.equals("0")){
            return 52;
        }
        else if(s.equals("1")){
            return 53;
        }
        else if(s.equals("2")){
            return 54;
        }
        else if(s.equals("3")){
            return 55;
        }
        else if(s.equals("4")){
            return 56;
        }
        else if(s.equals("5")){
            return 57;
        }
        else if(s.equals("6")){
            return 58;
        }
        else if(s.equals("7")){
            return 59;
        }
        else if(s.equals("8")){
            return 60;
        }
        else if(s.equals("9")){
            return 61;
        }
        else if(s.equals("+")){
            return 62;
        }
        else if(s.equals("/")){
            return 63;
        }
        return 0;
    }
}
class POPRequester implements Runnable{
    Towers tow;
    Thread t;
    public POPRequester(Towers tow){
        this.tow=tow;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        try{
            Socket so=new Socket(tow.popserver.getText(),110);
            InputStream is=so.getInputStream();
            OutputStream os=so.getOutputStream();
            DataInputStream dis=new DataInputStream(is);
            PrintStream ps=new PrintStream(os);
            String welc=dis.readLine();
            tow.info.setText(welc);
            ps.print("USER "+tow.username.getText()+"\r\n");
            tow.info.setText(dis.readLine());
            ps.print("PASS "+tow.password.getText()+"\r\n");
            tow.info.setText(dis.readLine());
            ps.print("STAT\r\n");
            String leninf=dis.readLine();
//System.out.println(leninf);
            leninf=leninf.substring(4);
            int leno=leninf.indexOf(" ");
            leninf=leninf.substring(0,leno);
            int len=new Integer(leninf).intValue();
            boolean nomails=true;
            for(int i=0;i<len;i++){
//System.out.println("i: "+i);
                ps.print("TOP "+(i+1)+" 5\r\n");
                String inp="";
                String fromline="";
                while((inp=dis.readLine())!=null&&!"".equals(inp)){
                    if(inp.length()>=5&&inp.substring(0,5).toLowerCase().equals("from:")){
                        fromline=inp;
                    }
//System.out.println("inp1: "+inp);
                }
//System.out.println("wend");
                String s1=dis.readLine();
//System.out.println("s1: "+s1);
                if(!".".equals(s1)){
                    s1=dis.readLine();
//System.out.println("s1: "+s1);
                    if(!".".equals(s1)){
                        s1=dis.readLine();
//System.out.println("s1: "+s1);
                    }
                }
//System.out.println("s1: "+s1);
                String inp2=dis.readLine();
                String mtype=dis.readLine();
//System.out.println("inp2: "+inp2);
String okstr=dis.readLine();
//                while(!(inp=dis.readLine()).equals(".")){
//System.out.println("inp3: "+inp);
//                }
                if("SCHACH TOWERS3D".equals(inp2)){
                    nomails=false;
                    ps.print("RETR "+(i+1)+"\r\n");
                    while(!(inp=dis.readLine()).equals("")){
                    }
                    String info="";
                    while(!(inp=dis.readLine()).equals(".")){
                        info=info+inp+"\r\n";
                    }
                    try{
                        tow.add(info,fromline,mtype);
                    }
                    catch(Exception exc){tow.info.setText("adderror: "+exc);};
                    ps.print("DELE "+(i+1)+"\r\n");
                    String deli=dis.readLine();
                }
                else{
                }
            }
            ps.print("QUIT\r\n");
            String qstr=dis.readLine();
            if(nomails){
                tow.info.setText("no mails in inbox");
            }
            else{
                tow.info.setText("mails loaded");
            }
        }
        catch(Exception e){
            tow.info.setText("loadmails error: "+e);
        }
    }
}
